Index: /trunk/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
 
@@ -42,5 +42,7 @@
 #include "TLibEncoder/TEncSbac.h"
 #include "TLibDecoder/TDecSbac.h"
-
+#if NH_MV
+#include <set>
+#endif
 
 //! \ingroup TLibCommon
@@ -139,15 +141,11 @@
 , m_pocMsbValRequiredFlag         (false)
 #endif
-#if NH_3D_IC
+#if NH_3D
 , m_bApplyIC                      (false)
 , m_icSkipParseFlag               (false)
-#endif
-#if NH_3D
 , m_inCmpPredFlag                 (false)
 , m_numViews                      (0)
 , m_depthToDisparityB             (NULL)
 , m_depthToDisparityF             (NULL)
-#endif
-#if NH_3D_DIS
 , m_bApplyDIS                     (false)
 #endif
@@ -289,5 +287,5 @@
     m_iSliceChromaQpDelta[component] = 0;
   }
-#if NH_3D_IV_MERGE
+#if NH_3D
   m_maxNumMergeCand = MRG_MAX_NUM_CANDS_MEM;
 #else
@@ -300,5 +298,5 @@
   m_cabacInitFlag        = false;
   m_enableTMVPFlag = true;
-#if NH_3D_TMVP
+#if NH_3D
   m_aiAlterRefIdx[0]                  = -1;
   m_aiAlterRefIdx[1]                  = -1;
@@ -828,5 +826,4 @@
 }
 #if NH_3D
-#if NH_3D_TMVP
 Void TComSlice::generateAlterRefforTMVP()
 {
@@ -849,5 +846,4 @@
   }
 }
-#endif
 #endif
 
@@ -1169,8 +1165,6 @@
   }
 #endif
-#if NH_3D_DIS
+#if NH_3D
   m_bApplyDIS = pSrc->m_bApplyDIS;
-#endif
-#if NH_3D_IC
   m_bApplyIC = pSrc->m_bApplyIC;
   m_icSkipParseFlag = pSrc->m_icSkipParseFlag;
@@ -1967,15 +1961,15 @@
   for( Int i = 0; i < MAX_NUM_LAYERS; i++ )
   {
-    m_layerIdInNuh      [i] = ( i == 0 ) ? 0 : -1; 
-    m_numDirectRefLayers[i] = 0; 
+    m_layerIdInNuh        [i] = ( i == 0 ) ? 0 : -1; 
+    m_numDirectRefLayers  [i] = 0; 
 #if NH_3D
-    m_numRefListLayers[i] = 0; 
-#endif
-    m_vpsRepFormatIdx    [i] = 0; 
+    m_numRefListLayers    [i] = 0; 
+#endif
+    m_vpsRepFormatIdx     [i] = 0; 
     m_pocLsbNotPresentFlag[i] = 0;    
-    m_viewIdVal          [i] = 0; 
+    m_viewIdVal           [i] = 0; 
 
 #if NH_3D
-    m_viewIndex         [i] = -1; 
+    m_viewIndex           [i] = -1; 
 #endif
 
@@ -1998,6 +1992,4 @@
       m_dimensionId[i][j] = 0;
     }
-#if NH_3D_ARP
-#endif
   }  
 #endif
@@ -2283,4 +2275,20 @@
 
 
+#if NH_3D
+Bool TComVPS::isFirstDepthLayer(Int layerIdInNuh) const
+{
+  Bool firstDepthLayer = false;
+  for(Int i = 0; i <= getMaxLayersMinus1(); i++  )
+  {
+    Int curLayerIdInNuh = getLayerIdInNuh( i );
+    if ( getVpsDepthFlag( curLayerIdInNuh ) )
+    {
+      firstDepthLayer =  ( curLayerIdInNuh == layerIdInNuh);
+      break;
+    }
+  }
+  return firstDepthLayer;
+}
+#endif
 
 Void TComVPS::deriveLayerSetLayerIdList()
@@ -2488,4 +2496,69 @@
 }
 
+
+Void TComVPS::printRepFormat() const
+{
+
+  vector<Int> idc;
+  vector<Int> width;
+  vector<Int> height; 
+  vector<Int> chromaAndBitDepthPresent;
+  vector<Int> chormaFormat;   
+  vector<Int> bitDepthLuma; 
+  vector<Int> bitDepthChroma;
+  vector<Int> conformanceWindowPresent; 
+  vector<Int> confLeftOff;
+  vector<Int> confRightOff;
+  vector<Int> confTopOff;
+  vector<Int> confBottomOff;
+
+  for (Int i = 0; i <= getVpsNumRepFormatsMinus1(); i++ )
+  {
+    const TComRepFormat* repFormat = getRepFormat( i );
+
+    idc                             .push_back(        i             );
+    width                           .push_back(  repFormat->getPicWidthVpsInLumaSamples()  );
+    height                          .push_back(  repFormat->getPicHeightVpsInLumaSamples() );
+    chromaAndBitDepthPresent        .push_back(  repFormat->getChromaAndBitDepthVpsPresentFlag() ? 1 : 0    );
+    chormaFormat                    .push_back(  repFormat->getChromaFormatVpsIdc()        );
+    bitDepthLuma                    .push_back(  repFormat->getBitDepthVpsLumaMinus8()     );
+    bitDepthChroma                  .push_back(  repFormat->getBitDepthVpsChromaMinus8()   );
+    conformanceWindowPresent        .push_back(  repFormat->getConformanceWindowVpsFlag()  );
+    confLeftOff                     .push_back(  repFormat->getConfWinVpsLeftOffset()      );
+    confRightOff                    .push_back(  repFormat->getConfWinVpsRightOffset()     );
+    confTopOff                      .push_back(  repFormat->getConfWinVpsTopOffset()       );
+    confBottomOff                   .push_back(  repFormat->getConfWinVpsBottomOffset()    );
+  }
+
+  std::cout << std::right << std::setw(60) << std::setfill('-') << " " << std::setfill(' ') << std::endl << "Rep Format" << std::endl; 
+  
+  std::vector<Int> repFormatIdx;
+
+  for (Int i = 0; i <= getMaxLayersMinus1(); i++ )
+  {
+    repFormatIdx.push_back( getVpsRepFormatIdx(i ) );
+  }
+
+  xPrintArray( "rep_format_idx", getMaxLayersMinus1()+1, repFormatIdx, false  );
+
+  std::cout << std::endl;
+
+  xPrintArray( "i"                                      , getVpsNumRepFormatsMinus1()+1, idc                                    , false, 6 );
+  xPrintArray( "pic_width_vps_in_luma_samples"          , getVpsNumRepFormatsMinus1()+1, width                                  , false, 6 );
+  xPrintArray( "pic_height_vps_in_luma_samples"         , getVpsNumRepFormatsMinus1()+1, height                                 , false, 6 );       
+  xPrintArray( "chroma_and_bit_depth_vps_present_flag"  , getVpsNumRepFormatsMinus1()+1, chromaAndBitDepthPresent               , false, 6 );     
+  xPrintArray( "chroma_format_vps_idc"                  , getVpsNumRepFormatsMinus1()+1, chormaFormat                           , false, 6 );     
+  xPrintArray( "bit_depth_vps_luma_minus8"              , getVpsNumRepFormatsMinus1()+1, bitDepthLuma                           , false, 6 );     
+  xPrintArray( "bit_depth_vps_chroma_minus8"            , getVpsNumRepFormatsMinus1()+1, bitDepthChroma                         , false, 6 );     
+  xPrintArray( "conformance_window_vps_flag"            , getVpsNumRepFormatsMinus1()+1, conformanceWindowPresent               , false, 6 );     
+  xPrintArray( "conf_win_vps_left_offset"               , getVpsNumRepFormatsMinus1()+1, confLeftOff                            , false, 6 );     
+  xPrintArray( "conf_win_vps_right_offset"              , getVpsNumRepFormatsMinus1()+1, confRightOff                           , false, 6 );     
+  xPrintArray( "conf_win_vps_top_offset"                , getVpsNumRepFormatsMinus1()+1, confTopOff                             , false, 6 );     
+  xPrintArray( "conf_win_vps_bottom_offset"             , getVpsNumRepFormatsMinus1()+1, confBottomOff                          , false, 6 );     
+
+  std::cout << std::endl;
+}
+
+
 Void TComVPS::printLayerDependencies() const
 {
@@ -2614,4 +2687,46 @@
   xPrintArray( "TargetDecLayerIdList", getNumOutputLayerSets(), rangeOutputLayerSets, numDecLayer,                     m_targetDecLayerIdLists, true );
   std::cout << endl;
+}
+
+IntAry1d TComVPS::getLayersOfVpsPtl(Int idxOfVpsPtl) const
+{
+  std::set<Int> applicableLayerIdsInVps;
+  // Get max chroma format and max bit depth of layers to which ptl is applicable to.
+
+  if ( idxOfVpsPtl == 0 || idxOfVpsPtl == 1 )
+  {
+    // If the profile_tier_level( ) syntax structure is included in an active SPS for the base layer or is the profile_tier_level( ) syntax structure 
+    // VpsProfileTierLevel[ 0 ], it applies to the OLS containing all layers in the bitstream but with only the base layer being the output layer.
+
+    // the value of profile_tier_level_idx[ 0 ][ 0 ] is inferred to be equal to 1, such that 
+    // VpsProfileTierLevel[ 1 ] applies to the 0-th OLS, which contains only the base layer that is the only output layer.
+
+    // Consider only the base layer
+    applicableLayerIdsInVps.insert( 0 );
+  }
+  else
+  {
+    // Otherwise, the profile_tier_level( ) syntax structure provides profile, tier and level to which a layer in an OLS conforms 
+    // and the profile_tier_level_idx[ i ][ j ] syntax element specifies that the profile_tier_level( ) syntax structure 
+    // VpsProfileTierLevel[ profile_tier_level_idx[ i ][ j ] ] applies to the j-th layer of the i-th OLS.
+
+    for (Int j = 0; j < getNumOutputLayerSets(); j++ )
+    {
+      for (Int k = 0; k < getNumOutputLayersInOutputLayerSet( j );  k++)
+      {
+        if ( getProfileTierLevelIdx(j,k)  == idxOfVpsPtl )
+        {
+          applicableLayerIdsInVps.insert( getLayerIdInVps( getTargetOptLayerIdList( j )[ k ]  ) );
+        }
+      }
+    }
+  }
+
+  IntAry1d layers;
+  for(std::set<Int>::iterator it = applicableLayerIdsInVps.begin(); it != applicableLayerIdsInVps.end(); ++it  )
+  {
+    layers.push_back( *it ); 
+  }
+  return layers;
 }
 
@@ -2774,6 +2889,7 @@
   m_spsMultilayerExtensionFlag = false;
   m_spsExtension5bits          = 0;
-  m_sps3dExtensionFlag         = false; 
-
+  m_sps3dExtensionFlag         = false;   
+  m_layerId                    = -1; 
+  m_inferredRepFormat          = NULL;
 #endif
 
@@ -2822,5 +2938,5 @@
 , m_numRefIdxL0DefaultActive         (1)
 , m_numRefIdxL1DefaultActive         (1)
-, m_TransquantBypassEnableFlag       (false)
+, m_TransquantBypassEnabledFlag      (false)
 , m_useTransformSkip                 (false)
 , m_dependentSliceSegmentsEnabledFlag(false)
@@ -2831,5 +2947,5 @@
 , m_numTileColumnsMinus1             (0)
 , m_numTileRowsMinus1                (0)
-, m_signHideFlag                     (false)
+, m_signDataHidingEnabledFlag        (false)
 , m_cabacInitPresentFlag             (false)
 , m_sliceHeaderExtensionPresentFlag  (false)
@@ -2842,5 +2958,5 @@
 , m_pocResetInfoPresentFlag          (false)
 #endif
-#if NH_3D_DLT
+#if NH_3D
 , m_cDLT                             ()
 #endif
@@ -2859,6 +2975,6 @@
 }
 
-#if NH_3D_DLT
-TComDLT::TComDLT()
+#if NH_3D
+TComDLT::TComDLT( )
 : m_bDltPresentFlag(false)
 , m_iNumDepthViews(0)
@@ -3004,12 +3120,48 @@
 
 #if NH_MV
-Void TComSPS::inferRepFormat( TComVPS* vps, Int layerIdCurr, Bool encoder )
-{
-  if ( getMultiLayerExtSpsFlag() )
-  {    
-    Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
-    const TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
-
-    if ( encoder )
+Void TComSPS::inferRepFormat( TComVPS* vps, Int layerIdCurr, Bool alreadySet )
+{ 
+  // Parameters are present in the SPS
+  // - base layer or muliLayerExpSpsFlag equal to zero
+
+  // It is a requirement of bitstream conformance that, when present, the value of chroma_format_idc, 
+  // separate_colour_plane_flag, pic_width_in_luma_samples, pic_height_in_luma_samples, bit_depth_luma_minus8 or 
+  // bit_depth_chroma_minus8 shall be less than or equal to chroma_format_vps_idc, separate_colour_plane_vps_flag, 
+  // pic_width_vps_in_luma_samples, pic_height_vps_in_luma_samples, bit_depth_vps_luma_minus8, or bit_depth_vps_chroma_minus8, 
+  // respectively, of the vps_rep_format_idx[ j ]-th rep_format( ) syntax structure 
+  // in the active VPS, where j is equal to LayerIdxInVps[ layerIdCurr ].
+
+  Bool baseLayer               = ( layerIdCurr == 0 );
+  Bool independentNonBaseLayer = vps->isIndependendNonBaseLayer( layerIdCurr );
+  Bool multiLayerExtSpsFlag    = getMultiLayerExtSpsFlag(); 
+
+  Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
+  const TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
+
+  assert( !( multiLayerExtSpsFlag && ( independentNonBaseLayer || baseLayer )) ); 
+
+  Bool presentInSps = !multiLayerExtSpsFlag;
+  if ( presentInSps )
+  {
+    // Values have been set before in xInitSps
+
+    assert( getChromaFormatIdc()      <=  repFormat->getChromaFormatVpsIdc()         ); 
+    //// ToDo: add when supported: 
+    ///  assert( getSeperateColourPlaneFlag() <=  repFormat->getSeparateColourPlaneVpsFlag() ) ; 
+
+    assert( getPicWidthInLumaSamples()  <= repFormat->getPicWidthVpsInLumaSamples()    ); 
+    assert( getPicHeightInLumaSamples() <= repFormat->getPicHeightVpsInLumaSamples()   ); 
+
+    assert( getBitDepth( CHANNEL_TYPE_LUMA   )  <= repFormat->getBitDepthVpsLumaMinus8()   + 8 );         
+    assert( getBitDepth( CHANNEL_TYPE_CHROMA )  <= repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
+  }
+
+  if ( !independentNonBaseLayer )
+  {
+
+    Window &spsConf    = getConformanceWindow();    
+
+    // Inference when not already done at the encoder.
+    if ( alreadySet )
     {
       assert( getChromaFormatIdc() ==  (ChromaFormat) repFormat->getChromaFormatVpsIdc() );         
@@ -3025,4 +3177,11 @@
       assert( getBitDepth              ( CHANNEL_TYPE_CHROMA ) == repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
       assert( getQpBDOffset            ( CHANNEL_TYPE_CHROMA ) == (Int) (6* ( getBitDepth( CHANNEL_TYPE_CHROMA ) -8 ) ) );
+
+      
+      assert( spsConf.getWindowLeftOffset  () == repFormat->getConfWinVpsLeftOffset()    );
+      assert( spsConf.getWindowRightOffset () == repFormat->getConfWinVpsRightOffset()   );
+      assert( spsConf.getWindowTopOffset   () == repFormat->getConfWinVpsTopOffset()     );
+      assert( spsConf.getWindowBottomOffset() == repFormat->getConfWinVpsBottomOffset()  );            
+
     }
     else
@@ -3040,6 +3199,5 @@
       setBitDepth              ( CHANNEL_TYPE_CHROMA, repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
       setQpBDOffset            ( CHANNEL_TYPE_CHROMA, (Int) (6* ( getBitDepth( CHANNEL_TYPE_CHROMA ) -8 ) ) );
-      Window &spsConf    = getConformanceWindow();    
-
+      
       // Scaled later
       spsConf.setScaledFlag( false ); 
@@ -3049,18 +3207,6 @@
       spsConf.setWindowBottomOffset( repFormat->getConfWinVpsBottomOffset()  );            
     }
-
-   if ( getMultiLayerExtSpsFlag() && getUpdateRepFormatFlag() )
-    {
-      assert( getChromaFormatIdc()      <=  repFormat->getChromaFormatVpsIdc()         ); 
-      //// ToDo: add when supported: 
-      // assert( getSeperateColourPlaneFlag() <=  repFormat->getSeparateColourPlaneVpsFlag() ) ; 
-
-      assert( getPicWidthInLumaSamples()  <= repFormat->getPicWidthVpsInLumaSamples()    ); 
-      assert( getPicHeightInLumaSamples() <= repFormat->getPicHeightVpsInLumaSamples()   ); 
-
-      assert( getBitDepth( CHANNEL_TYPE_LUMA   )  <= repFormat->getBitDepthVpsLumaMinus8()   + 8 );         
-      assert( getBitDepth( CHANNEL_TYPE_CHROMA )  <= repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
-    }
-  }
+  }
+  
 
   // Set conformance window
@@ -3068,16 +3214,4 @@
   getConformanceWindow().scaleOffsets( scal );
   getVuiParameters()->getDefaultDisplayWindow().scaleOffsets( scal );
-
-  if (encoder && getMultiLayerExtSpsFlag() )
-  { 
-    Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
-    const TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
-
-    Window &spsConf    = getConformanceWindow();    
-    assert( spsConf.getWindowLeftOffset  () == repFormat->getConfWinVpsLeftOffset()    );
-    assert( spsConf.getWindowRightOffset () == repFormat->getConfWinVpsRightOffset()   );
-    assert( spsConf.getWindowTopOffset   () == repFormat->getConfWinVpsTopOffset()     );
-    assert( spsConf.getWindowBottomOffset() == repFormat->getConfWinVpsBottomOffset()  );            
-  }
 }
 
@@ -3092,5 +3226,5 @@
 }
 
-Void TComSPS::inferSpsMaxDecPicBufferingMinus1( TComVPS* vps, Int targetOptLayerSetIdx, Int currLayerId, Bool encoder )
+Void TComSPS::inferSpsMaxDecPicBufferingMinus1( TComVPS* vps, Int targetOptLayerSetIdx, Int currLayerId, Bool doCheck )
 {
   if ( getMultiLayerExtSpsFlag() )
@@ -3116,5 +3250,5 @@
       Int maxNumReorderPics       = vps->getDpbSize()->getMaxVpsNumReorderPics( targetOptLayerSetIdx, i ); 
       Int maxLatencyIncreasePlus1 = vps->getDpbSize()->getMaxVpsLatencyIncreasePlus1( targetOptLayerSetIdx, i ); 
-      if ( encoder )      
+      if ( doCheck )      
       {
         assert( getMaxDecPicBuffering( i ) - 1 == maxDecPicBufferingMinus1 ); 
@@ -3602,5 +3736,5 @@
 }
 #endif
-#if NH_3D_NBDV
+#if NH_3D
 Void TComSlice::setDefaultRefView()
 {
@@ -3636,7 +3770,5 @@
   }
 }
-#endif
-
-#if NH_3D_ARP
+
 Void TComSlice::setARPStepNum( TComPicLists*ivPicLists )
 {
@@ -3722,7 +3854,5 @@
   }
 }
-#endif
-
-#if NH_3D_IC
+
 // This is an encoder only function and should be moved to TEncSlice or TEncSearch!!
 Void TComSlice::xSetApplyIC(Bool bUseLowLatencyICEnc)
@@ -3860,6 +3990,5 @@
   }//if(bUseLowLatencyICEnc)
 }
-#endif
-#if NH_3D_QTL
+
 Void TComSlice::setIvPicLists( TComPicLists* m_ivPicLists )
 {  
@@ -3879,12 +4008,6 @@
   
   setupLUT = setupLUT || getViewSynthesisPredFlag( ); 
-
-#if NH_3D_NBDV_REF
   setupLUT = setupLUT || getDepthRefinementFlag( );
-#endif  
-
-#if NH_3D_IV_MERGE
   setupLUT = setupLUT || ( getIvMvPredFlag() && getIsDepth() );
-#endif
 
   Int bitDepthY = getSPS()->getBitDepth(CHANNEL_TYPE_LUMA);
@@ -4388,5 +4511,6 @@
     if( getVPS()->getViewCompLayerPresentFlag( m_inCmpRefViewIdcs[ i ], !getIsDepth() ) )
     {
-      Int j = getVPS()->getLayerIdInVps( getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() ) );
+      Int jInNuh = getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() );
+      Int j = getVPS()->getLayerIdInVps( jInNuh );
       if  ( getVPS()->getDirectDependencyFlag( getVPS()->getLayerIdInVps( getLayerId() ) ,  j ) &&
         getVPS()->getSubLayersVpsMaxMinus1( j ) >= getTemporalId()   &&
@@ -4738,8 +4862,10 @@
 , m_spsMap(MAX_NUM_SPS)
 , m_ppsMap(MAX_NUM_PPS)
-, m_activeVPSId(-1)
 #if !NH_MV
 , m_activeSPSId(-1)
-#endif
+#else
+, m_spsActiveForLayer(MAX_NUM_LAYERS)
+#endif
+, m_activeVPSId(-1)
 {
 #if NH_MV  
@@ -4861,4 +4987,16 @@
 
   return false;
+}
+
+template <>
+Void ParameterSetMap<TComPPS>::setID(TComPPS* parameterSet, const Int psId)
+{
+  parameterSet->setPPSId(psId);
+}
+
+template <>
+Void ParameterSetMap<TComSPS>::setID(TComSPS* parameterSet, const Int psId)
+{
+  parameterSet->setSPSId(psId);
 }
 
@@ -4941,16 +5079,16 @@
 }
 
-Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> &newData)
+Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> *pNewData)
 {
   if (!bChanged)
   {
-    if ((pOldData==0 && pOldData!=0) || (pOldData!=0 && pOldData==0))
+    if ((pOldData==0 && pNewData!=0) || (pOldData!=0 && pNewData==0))
     {
       bChanged=true;
     }
-    else if (pOldData!=0 && pOldData!=0)
+    else if (pOldData!=0 && pNewData!=0)
     {
       // compare the two
-      if (pOldData->size() != pOldData->size())
+      if (pOldData->size() != pNewData->size())
       {
         bChanged=true;
@@ -4958,5 +5096,5 @@
       else
       {
-        const UChar *pNewDataArray=&(newData)[0];
+        const UChar *pNewDataArray=&(*pNewData)[0];
         const UChar *pOldDataArray=&(*pOldData)[0];
         if (memcmp(pOldDataArray, pNewDataArray, pOldData->size()))
